-- I recommend matching thread name & folder name!
walk_toggle = ScriptThread("cge_walk_toggle")

-- Run
function walk_toggle:Run()

	-- USER OPTIONS (set to true or false)
	
		local mod_enabled = true			-- Enable/Disable
		local equip_toggle = true			-- Equipping or unequiping a weapon toggles walking mode
		
	-------------------------------------------------------------
	
	local looking_behind = 0
	local walking = true
	local equip_check = false
	local equip_check_timer = 0
	local was_armed = false
	
	while self:IsRunning() do
		
		-- Mod Enabled
		if mod_enabled 
		then
				
			-- Player Info
			local player_id = natives.PLAYER.PLAYER_ID()
			local player_ped_id = natives.PLAYER.PLAYER_PED_ID()
		
			-- On Foot
			if natives.PED.IS_PED_ON_FOOT(player_ped_id)
			then
				
				-- Walk Toggle
				if natives.CONTROLS.IS_CONTROL_PRESSED(0, 26) and not natives.CONTROLS.IS_CONTROL_PRESSED(0, 25)
				then
					looking_behind = looking_behind + 1
				end
				
				if natives.CONTROLS.IS_CONTROL_JUST_RELEASED(0, 26)
				then
				
					if looking_behind == 1
					then
					
						if walking
						then
							walking = false
							natives.PED.SET_PED_USING_ACTION_MODE(player_ped_id, true, -1, 0)
							natives.CONTROLS.ENABLE_CONTROL_ACTION(0, 21, true)
						else
							walking = true
							natives.PED.SET_PED_USING_ACTION_MODE(player_ped_id, false, -1, 0)
							if natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4
							then
								natives.CONTROLS.DISABLE_CONTROL_ACTION(0, 21, true)
							end
						end
						
					end
					
					looking_behind = 0
					
				end
				
				-- Equip Toggle
				if equip_toggle
				then
				
					if natives.CONTROLS.IS_CONTROL_JUST_RELEASED(0, 37)
					then
						if natives.WEAPON.IS_PED_ARMED(player_ped_id, 7)
						then
							was_armed = true
						else
							was_armed = false
						end
						equip_check = true
					end
				
					if equip_check
					then
						if equip_check_timer > 10
						then

							equip_check = false
							equip_check_timer = 0
							
							if natives.WEAPON.IS_PED_ARMED(player_ped_id, 7) and not armed
							then
								walking = false
								natives.PED.SET_PED_USING_ACTION_MODE(player_ped_id, true, -1, 0)
								natives.CONTROLS.ENABLE_CONTROL_ACTION(0, 21, true)
							elseif was_armed
							then
								walking = true
								natives.PED.SET_PED_USING_ACTION_MODE(player_ped_id, false, -1, 0)
								if natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4
								then
									natives.CONTROLS.DISABLE_CONTROL_ACTION(0, 21, true)
								end
							end
							
						else
							equip_check_timer = equip_check_timer + 1
						end
					end
				
				end
					
				-- Sprint
				if natives.CONTROLS.IS_DISABLED_CONTROL_PRESSED(0, 21) or not natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4
				then
					natives.CONTROLS.ENABLE_CONTROL_ACTION(0, 21, true)
				else
				
					-- Enforce Modes
					if not natives.PED.GET_PED_STEALTH_MOVEMENT(player_ped_id)
					then
						if walking
						then
							if natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4
							then
								natives.CONTROLS.DISABLE_CONTROL_ACTION(0, 21, true)
							end
						else
							natives.PED.SET_PED_USING_ACTION_MODE(player_ped_id, true, -1, 0)
						end
					end
					
				end
				
				-- Reset Toggle
				if (natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4 and not natives.PED.GET_PED_STEALTH_MOVEMENT(player_ped_id) and (not natives.CONTROLS.IS_CONTROL_PRESSED(0, 21) and natives.CONTROLS.IS_CONTROL_ENABLED(0, 21))) 
				or (not natives.CAM.GET_FOLLOW_PED_CAM_VIEW_MODE() == 4 and not natives.PED.IS_PED_USING_ACTION_MODE(player_ped_id))
				then
					walking = false
				end
								
			end
			
		end
		
		-- Wait
		self:Wait(1)
		
	end
	
end

-- OnError
function walk_toggle:OnError()
	print("walk_toggle Thread caused an error!")
	self:Reset()
end

-- Register
walk_toggle:Register()